#include "demo.i"

		.global	m_cube
		.global	addspoke

#define NFACE 12

#define PIVOTX 31
#define PIVOTY 23

m_cube:
		lds	r17, ch+1*c_sz+c_ivol
		lds	r18, ch+0*c_sz+c_ivol
		add	r17, r18
		lds	r18, noisevol
		add	r17, r18
		ldi	r18, 56
		mul	r17, r18
		neg	r1
		st	Y, r1

		rcall	rle_clear

		; For each face, transform and project the three vertices
		; and draw the triangle.

		in	r16, GPIOR2
		in	r15, GPIOR1
		lsr	r16
		ror	r15
	
		ldi	r28, NFACE - 1
		ldi	r31, hi8(cubemodel)
		ldi	r30, lo8(cubemodel)
1:
		rcall	getvertex
		movw	r20, r16
		rcall	getvertex
		movw	r22, r16
		rcall	getvertex
		movw	r24, r16

		push	r15
		push	r28
		push	r30
		push	r31

		ldi	r18, 0x80
		sbrc	r29, 6
		ldi	r18, 0xc0
		rcall	rle_tri

		pop	r31
		pop	r30
		pop	r28
		pop	r15

		subi	r28, 1
		brcc	1b

		; Draw the background

		in	r30, GPIOR1
		lds	r19, spokes
2:
		subi	r19, 1
		brpl	3f
		ret
3:
		ldi	r31, hi8(sine)
		ldi	r20, PIVOTX
		ldi	r21, PIVOTY

		lpm	r16, Z		;	sin(a)
		subi	r30, 256-64
		lpm	r17, Z		;	cos(a)

		asr	r16
		subi	r16, 256-PIVOTX
		asr	r17
		subi	r17, 256-PIVOTY
		movw	r22, r16

		subi	r30, 42

		lpm	r17, Z		;	cos(b)
		subi	r30, 64
		lpm	r16, Z		;	sin(b)

		asr	r16
		subi	r16, 256-PIVOTX
		asr	r17
		subi	r17, 256-PIVOTY
		movw	r24, r16

		subi	r30, 43

		push	r19
		push	r30

		ldi	r18, 0x40
		rcall	rle_tri

		pop	r30
		pop	r19

		rjmp	2b

getvertex:
		lpm	r29, Z+

		push	r20
		push	r21
		push	r22
		push	r30
		push	r31

		ldi	r20, 0x38
		ldi	r21, 0x38
		ldi	r22, 0x38

		sbrc	r29, 2
		neg	r20
		sbrc	r29, 1
		neg	r21
		sbrc	r29, 0
		neg	r22

		;	r15	animation parameter
		;	r20	x (1.7 fixpoint, signed)
		;	r21	y (1.7 fixpoint, signed)
		;	r22	z (1.7 fixpoint, signed)

		; Transform x, y, z into x', y', z' by rotation.

		ldi	r31, hi8(sine)

		movw	r16, r20
		mov	r30, r15
		lsl	r30
		rcall	rotate

		mov	r20, r16
		mov	r16, r17
		mov	r17, r22
		mov	r30, r15
		lsl	r30
		add	r30, r15
		rcall	rotate

		mov	r21, r16
		mov	r22, r17

		; Perform z division by multiplying by 1/z.

		ldi	r16, 16		; fov control
		mov	r1, r16
		eor	r0, r0

		asr	r22
		subi	r22, 256-100	; fov control
		lds	r19, scratch
		add	r19, r22

		rcall	divu16u8
		mov	r19, r24

		mulsu	r20, r19
		mov	r16, r1
		subi	r16, 256-96-1

		lds	r30, coppertime+cl_xoffs	; would cause tearing, but looks ok
		lsr	r30
		lpm	r17, Z		; [0, 127]
		subi	r17, 128
		sbrc	r30, 6
		neg	r17
		subi	r17, 128	; [0, 255]

		lsr	r17
		sub	r16, r17

		mulsu	r21, r19
		mov	r17, r1
		subi	r17, 256-24

		pop	r31
		pop	r30
		pop	r22
		pop	r21
		pop	r20

		ret

addspoke:
		lds	r16, spokes
		inc	r16
		sts	spokes, r16
		ret
