#include "demo.i"

		.global	l_labyrinth
		.global	m_labyrinth

l_labyrinth:

		DE111				; t246

		; X -> table of column heights.

		ldi	r27, 0x02		;				1
		ldi	r26, 0x00		;				1
		sbic	GPIOR0, GFLAG_DBLBUF	;				\_ 2
		ldi	r26, 0x80		;				/

		; Y -> table of column colours (even or odd).

		ldi	r29, 0x03		;				1
		sbrc	r19, 0			;				\_ 2
		ldi	r29, 0x04		;				/
		ldi	r28, 0x00		;				1
		sbic	GPIOR0, GFLAG_DBLBUF	;				\_ 2
		ldi	r28, 0x80		;				/

		; Set r20 to current y distance from origo.

		mov	r20, r19		;				1
		subi	r20, 128		;				1
		sbrc	r20, 7			;				\_ 2
		neg	r20			;				/

		; Set r21 to background colour (even or odd).

		ldi	r21, 0x34		;				1
		sbrc	r19, 0			;				\_ 2
		ldi	r21, 0x43		;				/
		sbrc	r19, 7			;				\_ 2
		ldi	r21, 0x44		;				/

		lds	r18, scratch+2		;				2
		cpi	r18, 0x40		;				1
		brsh	3f			;				\_ 2
		ldi	r21, 0x33		;				/
3:
		ldi	r18, 69			;				1
1:
		ld	r16, X+			; t382 (+11n)			\_ 11
		ld	r17, Y+			;				|
		cp	r20, r16		;				|
		brlo	2f			;				|
		mov	r17, r21		;				|
2:		out	PORTD, r17		; t389 (+11n)			|
		subi	r18, 1			;				|
		brne	1b			;				/ (-1)

		rjmp	de6bde5end		; t5

m_labyrinth:
		in	r16, GPIOR1
		in	r17, GPIOR2
		ldi	r18, 64
		mul	r17, r18
		mov	r19, r0
		mul	r16, r18
		add	r1, r19
		std	Y+0, r0
		std	Y+1, r1

		ldd	r16, Y+9
		subi	r16, 3
		brcc	1f

		;add	r14, r2
		add	r14, r2
1:
		std	Y+9, r16

		sbrc	r16, 7
		com	r16			; [0, 127]

		lsl	r16
		brmi	3f
		lsl	r16
		brpl	2f
3:
		ldi	r16, 0x80
2:
		; r16 is in the range [0, 128] and will be multiplied with colours globally
		std	Y+2, r16

		ldi	r28, 69-1
loop:
		; Direction vector through screen coordinate r28 is (r28 - 35, 35) for 45 degree fov.

		mov	r16, r28
		subi	r16, 35
		lsl	r16
		ldi	r17, 38<<1		; fov control

		; Animate direction.

		ldi	r31, hi8(sine)
		lds	r30, scratch+1
		push	r30
		lsl	r30
		add	r30, r14
		rcall	rotate
		movw	r22, r16

		ldi	r20, 0
		sbrc	r22, 7
		ldi	r20, 0xff

		ldi	r21, 0
		sbrc	r23, 7
		ldi	r21, 0xff

		; r20:r22 = x distance per time unit
		; r21:r23 = y distance per time unit

		; Start raycasting at origo.
		; r25:r24 = current x coordinate
		; r27:r26 = current y coordinate
		; Z = current wall height (8.8 fixpoint)

		ldi	r25, 0x04
		ldi	r24, 0x00
		lds	r26, scratch+0
		pop	r27

		ldi	r18, 246

		ldi	r30, 0
		ldi	r31, 155
1:
		mov	r16, r25
		and	r16, r27
		sbrc	r16, 3
		rjmp	8f

		add	r24, r22
		adc	r25, r20
		add	r26, r23
		adc	r27, r21

		; Decay wall height by doing Z -> (Z * decay) >> 8

		mul	r30, r18
		mov	r17, r1
		mul	r31, r18
		add	r0, r17
		adc	r1, r3
		movw	r30, r0

		cpi	r31, 5
		brsh	1b
8:
emit:
		mov	r19, r31

		ldi	r23, 160
		fmul	r23, r19

		; r1 = height of column
		push	r1

		subi	r19, 256-8
		swap	r19
		andi	r19, 0x07

		lds	r16, scratch+2
		fmul	r19, r16
		mov	r19, r1

		pop	r1

		mov	r16, r19
		swap	r19
		or	r19, r16
		subi	r19, 256-0x33

		mov	r16, r19
		cpi	r16, 0x44
		brlo	5f

		cpi	r16, 0x99
		brlo	4f
		ldi	r19, 0x99
		ldi	r16, 0x99
4:
		subi	r16, 0xf1
5:
		ldi	r26, 0x00
		ldi	r27, 0x02
		sbis	GPIOR0, GFLAG_DBLBUF
		ldi	r26, 0x80

		add	r26, r28

		st	X, r1
		inc	r27
		st	X, r19
		inc	r27
		st	X, r16

		subi	r28, 1
		brcs	9f
		rjmp	loop
9:
		ret
