#include "demo.i"
#include "generated.i"

		.global	m_quilt

UPPER		=	0x42		; second last row
LOWER		=	0xa1		; last row

getbottom:
		cpi	r17, TILE_Q1
		breq	1f
		cpi	r17, TILE_Q2
		breq	1f
		cpi	r17, TILE_STALAGM
		breq	1f
		movw	r20, r24
		ret
1:
		movw	r20, r22
		ret

m_quilt:
		; Scroll past the bottom row.

		ldi	r16, 16
		sts	yscroll, r16

		; Move the entire buffer one row upwards. Must complete during
		; vblank, otherwise we might display a tile with an invalid colour.

		ldi	r26, 0x08	; first row
		ldi	r27, 0x02
		ldi	r28, 0x67	; second row
		ldi	r29, 0x02
1:
		ld	r16, Y+
		st	X+, r16
		cpi	r29, 0x05
		brne	1b

		; In the following code, r27 remains at 0x04.
		; The last two rows fit within that page.

		; Pick a random starting point (pivot)

		ldi	r16, 19
		rcall	rand

		mov	r18, r1
		push	r18

		ldi	r26, UPPER
		rcall	gettile
		rcall	getbottom

		; Place a blank tile with matching bg colour.

		ldi	r26, LOWER
		ldi	r17, TILE_BLANK
		movw	r24, r20
		rcall	puttile

		; Fill to the left.

		movw	r28, r20
		ldi	r19, 0xff
		rcall	fill

		; Fill to the right.

		pop	r18
		ldi	r26, LOWER
		rcall	gettile			; we know it's blank
		movw	r28, r24		; so just get the bg colour
		ldi	r19, 1
		rcall	fill

		; All done. Make the new row visible.

		ldi	r18, 14
5:
		sts	yscroll, r18

		rcall	waitvbl

		subi	r18, 2
		brcc	5b

		; Update colour range.

		ldi	r28, lo8(scratch)
		ldi	r29, hi8(scratch)

		ldd	r16, Y+0
		ldd	r17, Y+1
		in	r18, GPIOR2
		cpi	r18, 7
		brsh	8f
		subi	r16, 0x10
		sbc	r17, r3
		brcc	6f
		ret
8:
		ldi	r18, 0x27
		add	r16, r18
		adc	r17, r3
6:
		std	Y+0, r16
		std	Y+1, r17
		ret

fill:
		add	r18, r19
		cpi	r18, 19
		brsh	5f

		ldi	r26, UPPER
		rcall	gettile
		rcall	getbottom

		cp	r28, r20
		cpc	r29, r21
		breq	1f

		; Different colours.

		ldi	r16, 3
		ldi	r30, lo8(leftdiff - choices)
		sbrs	r19, 7
		ldi	r30, lo8(rightdiff - choices)

		rjmp	2f
1:
		; Same colours.
		; Pick a new colour (possibly same) for nominal fg.

		ldi	r16, 7
		rcall	rand
		inc	r1
		lds	r20, scratch+1
		sub	r1, r20
		brcc	6f

		ldi	r20, 0x33
		ldi	r21, 0x33
		rjmp	7f
6:
		ldi	r20, 0x35
		ldi	r21, 0x44
		ldi	r16, 0x11
		mul	r1, r16
		add	r20, r0
		add	r21, r0
7:
		ldi	r16, 6
		ldi	r30, lo8(leftsame - choices)
		sbrs	r19, 7
		ldi	r30, lo8(rightsame - choices)
2:
		rcall	rand
		add	r30, r1
		ldi	r31, hi8(choices)
		ldi	r16, lo8(choices)
		add	r30, r16
		adc	r31, r3
		lpm	r17, Z

		movw	r22, r20		; fg from above/new
		movw	r24, r28		; bg from side
		lsr	r17
		brcc	3f
		movw	r22, r28		; fg from side
		movw	r24, r20		; bg from above/new
3:
		lsr	r17
		brcs	4f
		movw	r28, r20		; set up new side colour
4:
		ldi	r26, LOWER
		rcall	puttile
		rjmp	fill
5:
		ret

#define REGULAR(t) ((t) << 2 | 0x00)
#define INVERTED(t) ((t) << 2 | 0x01)
#define ACROSS 0x02

choices:
leftdiff:	.byte	INVERTED(TILE_Q2), REGULAR(TILE_Q4), ACROSS | REGULAR(TILE_STALACT)
leftsame:	.byte	REGULAR(TILE_Q1), INVERTED(TILE_Q3), ACROSS | REGULAR(TILE_STALAGM), ACROSS | REGULAR(TILE_BLANK), ACROSS | REGULAR(TILE_BALL), ACROSS | REGULAR(TILE_HEART)
rightdiff:	.byte	INVERTED(TILE_Q1), REGULAR(TILE_Q3), ACROSS | REGULAR(TILE_STALACT)
rightsame:	.byte	REGULAR(TILE_Q2), INVERTED(TILE_Q4), ACROSS | REGULAR(TILE_STALAGM), ACROSS | REGULAR(TILE_BLANK), ACROSS | REGULAR(TILE_BALL), ACROSS | REGULAR(TILE_HEART)
