#include "demo.i"

		.global	l_rle
		.global	rle_clear
		.global	rle_tri

#define WIDTH 63
#define HEIGHT 47
#define STRIDE 8

l_rle:

		DE103				; t246

		; Prepare the palette

		lds	r16, coppertime+cl_colour	;			2

		ldi	r20, 0x33		;				1
		ldi	r21, 0x55		;				1
		ldi	r22, 0x99		;				1
		eor	r16, r19		;				1
		sbrc	r16, 0			;				\_ 2
		ldi	r22, 0xa8		;				/
		eor	r16, r19		;				1
		sbrc	r16, 1			;				\_ 2
		swap	r22			;				/

		mov	r23, r22		;				1
		subi	r23, 0x11		;				1

		ldi	r16, 47			;				1
		mul	r19, r16		;				2
		lsl	r1			;				1
		lsl	r1			;				1

		ldi	r29, 0x02		;				1
		ldi	r28, 0x10		;				1
		sbic	GPIOR0, GFLAG_DBLBUF	;				\_ 2
		ldi	r29, 0x03		;				/
		sbic	GPIOR0, GFLAG_DBLBUF	;				\_ 2
		ldi	r28, 0x88		;				/

		add	r28, r1			;				1
		adc	r29, r3			;				1
		add	r28, r1			;				1
		adc	r29, r3			;				1

		; Display the segments
1:						;				\_ 12 * WIDTH + 13
		ld	r17, Y+			; t377 (+12n)			|
		movw	r24, r20		;				|
		sbrc	r17, 7			;				|
		movw	r24, r22		;				|
		sbrc	r17, 6			;				|
		mov	r24, r25		;				|
		andi	r17, 0x3f		;				|
		out	PORTD, r24		; t385 (+12n)			|
2:						;				|
		subi	r17, 1			;				|
		breq	1b			;				|
						;				|
		brcs	3f			;				|
						;				|
		DE7				;				|
		rjmp	2b			;				/
3:
		out	PORTD, r2		;				1
		DE7				; t12
		rjmp	endofline		; t19				2

rle_findbuf:
		; Output:
		;	Z	start of frame buffer

		ldi	r31, 0x02
		ldi	r30, 0x10
		sbic	GPIOR0, GFLAG_DBLBUF
		ret
		ldi	r31, 0x03
		ldi	r30, 0x88
		ret

rle_clear:
		; Clobbers:
		;	r16, r17, Y
		; Output:
		;	Z	start of frame buffer

		rcall	rle_findbuf
		movw	r28, r30

		ldi	r16, HEIGHT
		ldi	r17, WIDTH
1:
		st	Y+, r17
		st	Y, r3
		adiw	r28, STRIDE - 1
		subi	r16, 1
		brne	1b
rle_ret:
		ret

rle_clipline:
		; Inputs:
		;	r18	Colour in high bits
		;	r20	First x, signed (will be clipped to [0, 62])
		;	r22	Second x, signed (will be clipped to [0, 62])
		;	r21	y, signed (will be clipped to [0, 46])
		;	Z	Start of frame buffer
		; Clobbers:
		;	r16, r17, r19

		cpi	r21, HEIGHT
		brsh	rle_ret

		mov	r16, r20
		mov	r17, r22

		cp	r17, r16
		brge	1f

		mov	r17, r20
		mov	r16, r22
1:
		subi	r17, 0xff
		brmi	rle_ret		; Clip if rightmost x is negative
		breq	rle_ret

		cpi	r16, WIDTH
		brge	rle_ret		; Clip if leftmost x is >= 63

		sbrc	r16, 7
		ldi	r16, 0		; Bound if leftmost x is negative

		cpi	r17, WIDTH
		brlt	2f
		ldi	r17, WIDTH	; Bound if rightmost x is > 63
2:
		push	r18
		push	r20
		;push	r22
		push	r26
		push	r27
		push	r28
		push	r29
		push	r30
		push	r31

		ldi	r19, STRIDE
		mul	r19, r21
		add	r30, r0
		adc	r31, r1

		;rcall	rle_merge	; inlined below
rle_merge:
		; Input:
		;	Z	Buffer line
		;	r16	Left edge of new segment, [0, 62]
		;	r17	Right edge of new segment + 1, >r16, [1, 63]
		;	r18	Colour of new segment in high bits (0x00, 0x40, 0x80 or 0xc0)

		; Clobbers:
		;	r16, r17, r18, r19, r20, X, Y

		; Phase 1: Merge the current list of segments with the
		; new segment into a temporary line buffer at 0x200 (up
		; to 10 bytes are used).

		;	X	Points to next free byte in temporary buffer
		;	Y	Current input segment

		ldi	r26, 0x00
		ldi	r27, 0x02
		movw	r28, r30
1:
		; 1. Consider the first old segment.

		ld	r19, Y+
		mov	r20, r19
		andi	r19, 0x3f
		breq	9f

		andi	r20, 0xc0
		breq	3f

		; 2. If the old segment wasn't black, just copy it and reduce the problem.
2:
		sub	r16, r19
		sub	r17, r19
		or	r20, r19
		st	X+, r20
		rjmp	1b
3:
		; 3. If the old segment doesn't overlap with the new one, copy and reduce.

		cp	r16, r19
		brge	2b

		cpi	r17, 1
		brlt	2b

		; 4. Draw the left remains of the old segment (black), if any.

		cpi	r16, 1
		brlt	4f

		st	X+, r16
		sub	r17, r16
		sub	r19, r16
		sub	r16, r16
4:
		; 5. Draw min(oldwidth, newwidth) pixels in the new colour.

		mov	r20, r19
		cp	r20, r17
		brlt	5f

		mov	r20, r17
5:
		tst	r20
		brmi	6f

		sub	r16, r20
		sub	r17, r20
		sub	r19, r20
		or	r20, r18
		st	X+, r20
6:
		; 6. Draw the right remains of the old segment (black), if any.

		tst	r19
		breq	1b
		
		st	X+, r19
		;sub	r16, r19
		sub	r17, r19
		rjmp	1b
9:
		st	X, r3

		; Phase 2: Copy the temporary buffer back into the
		; real line buffer, joining adjacent segments of
		; the same colour. If there are too many segments,
		; reset the line.
rle_merge_2:
		;	r16	bytes left in destination buffer
		;	r18	accumulation colour (in high bits)
		;	r20	accumulated number of pixels

		movw	r28, r30
		ldi	r26, 0x00
		ldi	r27, 0x02
		ldi	r16, STRIDE - 1

		ldi	r20, 0
		ldi	r18, 0
2:
		tst	r16
		breq	9f

		ld	r19, X+
		mov	r17, r19
		andi	r19, 0x3f
		breq	5f

		andi	r17, 0xc0
		cp	r17, r18
		brne	3f

		add	r20, r19
		rjmp	2b
3:
		tst	r20
		breq	4f

		or	r20, r18
		st	Y+, r20
		subi	r16, 1
4:
		mov	r20, r19
		mov	r18, r17
		rjmp	2b
9:
		movw	r28, r30
		ldi	r20, 0x3f
		ldi	r18, 0x00
5:
		or	r20, r18
		st	Y+, r20
		st	Y, r3
		;ret		; end of rle_merge

		pop	r31
		pop	r30
		pop	r29
		pop	r28
		pop	r27
		pop	r26
		;pop	r22
		pop	r20
		pop	r18

		ret

rle_tri:
		; Draw a filled triangle.
		; Inputs:
		;	r18	Colour in high bits
		;	r20	x1
		;	r21	y1
		;	r22	x2
		;	r23	y2
		;	r24	x3
		;	r25	y3

		; Perform backface culling

		muls	r20, r23
		movw	r28, r0
		muls	r20, r25
		sub	r28, r0
		sbc	r29, r1
		muls	r24, r23
		sub	r28, r0
		sbc	r29, r1
		muls	r22, r21
		sub	r28, r0
		sbc	r29, r1
		muls	r22, r25
		add	r28, r0
		adc	r29, r1
		muls	r24, r21
		add	r28, r0
		adc	r29, r1
		brpl	1f
		ret
1:
		; Sort vertices so that y1 <= y2 <= y3.

		cp	r23, r21
		brge	1f

		movw	r16, r20
		movw	r20, r22
		movw	r22, r16
1:
		cp	r25, r21
		brge	1f

		movw	r16, r20
		movw	r20, r24
		movw	r24, r16
1:
		cp	r25, r23
		brge	1f

		movw	r16, r22
		movw	r22, r24
		movw	r24, r16
1:
		; (x1, y1) is the top. Calculate dx/dy for the edges
		; towards (x2, y2) and (x3, y3) respectively.

		movw	r16, r24	; r25:r24 clobbered by division
		mov	r15, r18	; r18 clobbered by division

		mov	r1, r22
		sub	r1, r20
		eor	r0, r0
		mov	r19, r23
		sub	r19, r21
		rcall	divs16u8

		movw	r26, r24	; X is dx/dy from 1 to 2

		mov	r1, r16		; Formerly r24
		sub	r1, r20
		eor	r0, r0
		mov	r19, r17	; Formerly r25
		sub	r19, r21
		rcall	divs16u8

		movw	r28, r24	; Y is dx/dy from 1 to 3

		; Calculate dx/dy for the edge between (x2, y2) and
		; (x3, y3).

		mov	r1, r16		; Formerly r24
		sub	r1, r22
		eor	r0, r0
		mov	r19, r17	; Formerly r25
		sub	r19, r23
		rcall	divs16u8
					; r25:r24 is dx/dy from 2 to 3

		push	r25
		push	r24

		mov	r18, r15
		mov	r25, r17

		; Locate start of frame buffer.

		rcall	rle_findbuf

		mov	r15, r22

		; Draw upper part of triangle.

		eor	r14, r14	; r20:r14 is first x coordinate (8.8 fixpoint)
		mov	r22, r20	; r22:r24 is second x coordinate (8.8 fixpoint)
		eor	r24, r24
2:
		cp	r21, r23
		brge	3f

		rcall	rle_clipline

		add	r14, r26
		adc	r20, r27
		add	r24, r28
		adc	r22, r29
		inc	r21
		rjmp	2b
3:
		; Draw lower part of triangle.

		pop	r26
		pop	r27

		mov	r20, r15	; Ensure that we're at (x2, y2) even when y1 == y2
		eor	r14, r14
4:
		rcall	rle_clipline

		cp	r21, r25
		brge	5f

		add	r14, r26
		adc	r20, r27
		add	r24, r28
		adc	r22, r29
		inc	r21
		rjmp	4b
5:
		ret

