#include "demo.i"

		.global	waitvbl
		.global	divu16u8
		.global	divs16u8
		.global	rotate
		.global	v_nop
		.global	l_black
		.global	l_white
		.global	l_flash
		.global	l_end
		.global	blank
		.global	blankfield
		.global	delay3xplus8
		.global	delay3xplus7
		.global	delay3xplus6
		.global	rand

waitvbl:
		sbi	GPIOR0, GFLAG_VBLANK
1:
		sbic	GPIOR0, GFLAG_VBLANK
		rjmp	1b
v_nop:
		ret

l_black:
		DE508					;	t246
		DE400
		rjmp	endofline			;	t19

l_end:
		DE507					;	t246
		DE400
		mov	r15, r2				; 1
		rjmp	endofline			;	t19

l_white:
		DE142					;	t246
		ldi	r16, 0xaa			; 1
fill:
		out	PORTD, r16			; 1	t389
		DE763
		out	PORTD, r2			; 1	t18
		rjmp	endofline			;	t19

l_flash:
		DE138					;	t246
		lds	r16, coppertime+cl_flash	; 2
		subi	r16, 256-0x33			; 1
		rjmp	fill				; 2	t387

delay3xplus8:	nop
delay3xplus7:	nop
delay3xplus6:
1:		subi	r16, 1			;				1
		brcc	1b			;				2 in loop, 1 otherwise
		ret				;				4

divu16u8:
		; Divides r1:r0 by r19 and returns the quotient in r25:r24.
		; Clobbers r1, r0, r18 but preserves r19.

		clr     r18
		ldi     r24, 1
		ldi     r25, 0
1:
		lsl     r0
		rol     r1
		rol     r18
		brcs    2f
		cp      r18, r19
		brcs    3f
2:
		sub     r18, r19
		sec
		rjmp    4f
3:
		clc
4:
		rol     r24
		rol     r25
		brcc    1b

		ret

divs16u8:
		sbrs	r1, 7
		rjmp	divu16u8

		com	r1
		neg	r0
		brcs	1f
		inc	r1
1:
		rcall	divu16u8
		com	r25
		neg	r24
		sbci	r25, 0xff
		ret

rotate:
		; Rotates (r16, r17) by r30 angular units. Requires hi8(sine) in r31.
		; Clobbers r0, r1, r18, r19, X.

		lpm	r18, Z			; get sine
		subi	r30, 256-64
		lpm	r19, Z			; get cosine

		; xout = x cos - y sin
		; yout = x sin + y cos

		fmuls	r16, r19
		mov	r26, r1
		fmuls	r17, r18
		sub	r26, r1
		fmuls	r16, r18
		mov	r27, r1
		fmuls	r17, r19
		add	r27, r1
		movw	r16, r26

		ret

blank:
		ldi	r16, 128 + 0
		sts	vblvector, r16
		sts	mainvector, r16
blankfield:
		ldi	r19, lo8(fields)
		sts	copperfield, r19
		ret

rand:
		; Returns a pseudo-random integer in the range [0, r16[.
		; Output is in r1.

		rcall	randbit
		rcall	randbit
		rcall	randbit
		mul	r15, r16
		ret

randbit:
		lsl	r14
		rol	r15
		brvc	1f
		add	r14, r2
1:		ret
